// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDA_UIMM_PROVIDERSELECTOR_H
#define _LIBGDA_UIMM_PROVIDERSELECTOR_H


#include <glibmm.h>

/* libgda-uimm - a C++ wrapper for libgda-ui
 *
 * Copyright (c) 2010 libgda-uimm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgda-uimm/combo.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdauiProviderSelector GdauiProviderSelector;
typedef struct _GdauiProviderSelectorClass GdauiProviderSelectorClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace GdaUI
{ class ProviderSelector_Class; } // namespace GdaUI

} // namespace Gnome
namespace Gnome
{

// Gnome::Gda class forward declartions.
namespace Gda
{

class ServerProvider;

}

namespace GdaUI
{

/** ProviderSelector - Select a database provider from a combo box.
 */

class ProviderSelector :
  public Combo
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ProviderSelector CppObjectType;
  typedef ProviderSelector_Class CppClassType;
  typedef GdauiProviderSelector BaseObjectType;
  typedef GdauiProviderSelectorClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~ProviderSelector();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class ProviderSelector_Class;
  static CppClassType providerselector_class_;

  // noncopyable
  ProviderSelector(const ProviderSelector&);
  ProviderSelector& operator=(const ProviderSelector&);

protected:
  explicit ProviderSelector(const Glib::ConstructParams& construct_params);
  explicit ProviderSelector(GdauiProviderSelector* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GdauiProviderSelector*       gobj()       { return reinterpret_cast<GdauiProviderSelector*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GdauiProviderSelector* gobj() const { return reinterpret_cast<GdauiProviderSelector*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:


public:
  
  /** Create a new Gdaui::ProviderSelector widget.
   * @return The newly created widget.
   */

  explicit ProviderSelector();

public:
  
  /** Get the selected provider as a Gda::ServerProvider object
   * @return A new Gda::ServerProvider or <tt>0</tt> if an error occurred
   * 
   * @newin{4,2}.
   */
  Glib::RefPtr<Gnome::Gda::ServerProvider> get_provider_obj();
  
  /** Get the selected provider as a Gda::ServerProvider object
   * @return A new Gda::ServerProvider or <tt>0</tt> if an error occurred
   * 
   * @newin{4,2}.
   */
  Glib::RefPtr<const Gnome::Gda::ServerProvider> get_provider_obj() const;
  
  /** Get the selected provider.
   * @return The selected provider, or <tt>0</tt> if no provider is selected
   * 
   * @newin{4,2}.
   */
  Glib::ustring get_provider() const;
  
  /** Forces @a selector to be set on @a provider
   * @param provider The provider to be selected, or <tt>0</tt> for the default (SQLite).
   * @return <tt>true</tt> if @a provider has been selected
   * 
   * @newin{4,2}.
   */
  bool set_provider(const Glib::ustring& provider);


};

} // namespace GdaUI

} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::GdaUI::ProviderSelector
   */
  Gnome::GdaUI::ProviderSelector* wrap(GdauiProviderSelector* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGDA_UIMM_PROVIDERSELECTOR_H */

